Loading...
Searching...
No Matches
Sip_authorization

## Macros

#define | sip_authorization(sip)
| Access a SIP Authorization header structure sip_authorization_t from sip_t.
#define | SIP_AUTHORIZATION_INIT()
| Initializer for structure sip_authorization_t.
#define | SIPTAG_AUTHORIZATION(x)
| Tag list item for pointer to a Authorization header structure sip_authorization_t.
#define | SIPTAG_AUTHORIZATION_REF(x)
| Tag list item for reference to a Authorization header pointer.
#define | SIPTAG_AUTHORIZATION_STR(s)
| Tag list item for string with Authorization header value.
#define | SIPTAG_AUTHORIZATION_STR_REF(x)
| Tag list item for reference to a Authorization header string.

## Typedefs

typedef struct msg_auth_s | sip_authorization_t
| @

## Functions

issize_t | sip_authorization_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Authorization header.
issize_t | sip_authorization_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Authorization header.
sip_authorization_t * | sip_authorization_init (sip_authorization_t x[1])
| Initialize a structure sip_authorization_t.
int | sip_is_authorization (sip_header_t const *header)
| Test if header object is instance of sip_authorization_t.
sip_authorization_t * | sip_authorization_dup (su_home_t *home, sip_authorization_t const *hdr))
| Duplicate a list of Authorization header header structures sip_authorization_t.
sip_authorization_t * | sip_authorization_copy (su_home_t *home, sip_authorization_t const *hdr))
| Copy a list of Authorization header header structures sip_authorization_t.
sip_authorization_t * | sip_authorization_make (su_home_t *home, char const *s))
| Make a Authorization header structure sip_authorization_t.
sip_authorization_t * | sip_authorization_format (su_home_t *home, char const *fmt,...)))
| Make a Authorization header from formatting result.

## Variables

msg_hclass_t | sip_authorization_class []
| Header class for Authorization header.
tag_typedef_t | siptag_authorization
| Tag for Authorization header object.
tag_typedef_t | siptag_authorization_str
| Tag for string with Authorization header value.

## Detailed Description

## Macro Definition Documentation

## SIP_AUTHORIZATION_INIT

#define SIP_AUTHORIZATION_INIT | ( |  | ) |

Initializer for structure sip_authorization_t.

A static sip_authorization_t structure for Authorization header must be initialized with the SIP_AUTHORIZATION_INIT() macro. For instance,

sip_authorization_t sip_authorization = SIP_AUTHORIZATION_INIT;
sip_authorization_t
struct msg_auth_s sip_authorization_t
@
Definition sip.h:144
sip_authorization
#define sip_authorization(sip)
Access a SIP Authorization header structure sip_authorization_t from sip_t.
Definition sip_protos.h:10127
SIP_AUTHORIZATION_INIT
#define SIP_AUTHORIZATION_INIT()
Initializer for structure sip_authorization_t.
Definition sip_protos.h:10144

## SIPTAG_AUTHORIZATION

#define SIPTAG_AUTHORIZATION | ( |  | x | ) |

Tag list item for pointer to a Authorization header structure sip_authorization_t.

The SIPTAG_AUTHORIZATION() macro is used to include a tag item with a pointer to a sip_authorization_t structure in a tag list.

Parameters

  x | pointer to a sip_authorization_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_AUTHORIZATION_REF().

## SIPTAG_AUTHORIZATION_STR

#define SIPTAG_AUTHORIZATION_STR | ( |  | s | ) |

Tag list item for string with Authorization header value.

The SIPTAG_AUTHORIZATION_STR() macro is used to include a tag item with a string containing value of a sip_authorization_t header in a tag list.

Parameters

  s | pointer to a string containing Authorization header value, or NULL.

The string in SIPTAG_AUTHORIZATION_STR() can be converted to a sip_authorization_t header structure by giving the string s has second argument to function sip_authorization_make().

The corresponding tag taking reference parameter is SIPTAG_AUTHORIZATION_STR_REF().

## Typedef Documentation

## sip_authorization_t

typedef struct msg_auth_s sip_authorization_t

@

The Authorization header consists of credentials containing the authentication information of the user agent for the realm of the resource being requested. Its syntax is defined in RFC 2617 and RFC 3261 as follows:

Authorization = "Authorization" HCOLON credentials
credentials = ("Digest" LWS digest-response)
/ other-response
digest-response = dig-resp *(COMMA dig-resp)
dig-resp = username / realm / nonce / digest-uri
/ dresponse / algorithm / cnonce
/ opaque / message-qop
/ nonce-count / auth-param
username = "username" EQUAL username-value
username-value = quoted-string
digest-uri = "uri" EQUAL LDQUOT digest-uri-value RDQUOT
digest-uri-value = rquest-uri ; Equal to request-uri as specified
by HTTP/1.1
message-qop = "qop" EQUAL qop-value
cnonce = "cnonce" EQUAL cnonce-value
cnonce-value = nonce-value
nonce-count = "nc" EQUAL nc-value
nc-value = 8LHEX
dresponse = "response" EQUAL request-digest
request-digest = LDQUOT 32LHEX RDQUOT
auth-param = auth-param-name EQUAL
( token / quoted-string )
auth-param-name = token
other-response = auth-scheme LWS auth-param
*(COMMA auth-param)
auth-scheme = token
LWS
#define LWS

The parsed Authorization header is stored in sip_authorization_t structure.

See also
  RFC 2617, auth_mod_verify(), auth_mod_check(), auth_get_params(), auth_digest_response_get().

The structure sip_authorization_t contains representation of SIP Authorization header.

The sip_authorization_t is defined as follows:

typedef struct msg_auth_s {
msg_common_t au_common[1]; // Common fragment info
msg_auth_t *au_next; // Link to next header
char const *au_scheme; // Auth-scheme like "Basic" or "Digest"
msg_param_t const *au_params; // Comma-separated parameters
} sip_authorization_t;
msg_common_t
struct msg_common_s msg_common_t
msg_auth_s
msg_auth_s::au_scheme
char const * au_scheme
msg_auth_s::au_params
msg_param_t const * au_params
msg_auth_s::au_next
msg_auth_t * au_next
msg_auth_s::au_common
msg_common_t au_common[1]

## Function Documentation

## sip_authorization_copy()

sip_authorization_t * sip_authorization_copy | ( | su_home_t * | home,
|  | sip_authorization_t const * | hdr )

inline

Copy a list of Authorization header header structures sip_authorization_t.

The function sip_authorization_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  authorization = sip_authorization_copy(home, sip->sip_authorization);
  sip_authorization_copy
  sip_authorization_t * sip_authorization_copy(su_home_t *home, sip_authorization_t const *hdr))
  Copy a list of Authorization header header structures sip_authorization_t.
  Definition sip_protos.h:10274

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_authorization_dup()

sip_authorization_t * sip_authorization_dup | ( | su_home_t * | home,
|  | sip_authorization_t const * | hdr )

inline

Duplicate a list of Authorization header header structures sip_authorization_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  authorization = sip_authorization_dup(home, sip->sip_authorization);
  sip_authorization_dup
  sip_authorization_t * sip_authorization_dup(su_home_t *home, sip_authorization_t const *hdr))
  Duplicate a list of Authorization header header structures sip_authorization_t.
  Definition sip_protos.h:10231

Returns
  A pointer to the newly duplicated sip_authorization_t header structure, or NULL upon an error.

## sip_authorization_format()

sip_authorization_t * sip_authorization_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Authorization header from formatting result.

Make a new sip_authorization_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_authorization_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_authorization_init()

sip_authorization_t * sip_authorization_init | ( | sip_authorization_t | x[1] | ) |

inline

Initialize a structure sip_authorization_t.

An sip_authorization_t structure for Authorization header can be initialized with the sip_authorization_init() function/macro. For instance,

sip_authorization_t sip_authorization;
sip_authorization_init(&sip_authorization);
sip_authorization_init
sip_authorization_t * sip_authorization_init(sip_authorization_t x[1])
Initialize a structure sip_authorization_t.
Definition sip_protos.h:10162

## sip_authorization_make()

sip_authorization_t * sip_authorization_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Authorization header structure sip_authorization_t.

The function sip_authorization_make() makes a new sip_authorization_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_authorization_t header structure, or NULL upon an error.

## sip_is_authorization()

int sip_is_authorization | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_authorization_t.

Check if the header class is an instance of Authorization header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header authorization
  0 | (false) otherwise

## Variable Documentation

## sip_authorization_class

msg_hclass_t sip_authorization_class[]

extern

Header class for Authorization header.

The header class sip_authorization_class defines how a SIP Authorization header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_authorization_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.